Subject: Preliminary Vtprint FAQ
From: [email-masked] (Garrett D'Amore)
Date: Wed, 1 Jun 1994 20:31:46 GMT
Newsgroups: comp.os.linux.announce

The following is version 0.0 of the vtprint FAQ.  I just typed this up,
and hopefully it will help answer some questions people have had about
using vtprint.

I am working on vtprint 1.4 and should have it ready for release
sometime in the next few days.  Stay tuned for further info.

Also, at the same time as the release of vtprint 1.4, I will be
announcing a more "formal" mailing list (listserv style), so people can
subscribe and unsubscribe on their own.  This will hopefully make
the vtprint mailing list less arbitrary.  I don't intend to
automatically subscribe anyone to this list, but rather hope people
will subscribe on their own.  However, if you want to be placed on this
mailing list "by default", then please send me e-mail.  I hope to set up
this list sometime today or tomorrow.

If you have any comments on this FAQ, the proposed mailing list, or
vtprint in general, I'd be interested in hearing them.  Thanks!

	-- garrett

>>> Cut here <<<

The vtprint FAQ
===============

Garrett D'Amore
<[email-masked]>

Version 0.0
May 31, 1994

This document attempts to address some of the most common questions
relating to the vtprint program.  However, this document is still very
much under development (as is vtprint itself), there may be significant
omissions or errors.  The author apologizes for any such errors or
omissions, and kindly requests that the reader pass on any corrections
or requests for clarification/more data to him.

Table of Contents
=================

I. About vtprint
  1. What is "vtprint"?
  2. Who writes/supports vtprint?
  3. Where do I get vtprint?
  4. What do I need to use vtprint?

II. Installing vtprint
  1. How do I install vtprint?
  2. What if I don't have root access on the remote host?
  3. I have an account on NETCOM.COM.  Do I need to install my own copy
     of vtprint?

III. Using vtprint
  1. What help is available for using vtprint?
  2. How do I print text files using vtprint?
  3. How do I print binary files using vtprint?
  4. What about PostScript?
  5. How do I set up program X to use vtprint?

IV. Problems
  1. vtprint doesn't work! Nothing is output by the printer, or the
     text appears on my screen but not on the printer.
  2. vtprint prints a single line, but additional lines are starting at
     the wrong horizontal location, or aren't showing up at all! or Why
     can't I get anything past the first line or two to print
     correctly?
  3. Why aren't page breaks included between documents?

V. NETCOM Users
  1. How do I use the master copy in ~garrett/bin on Netcom?
  2. How do I view the man page on Netcom?
  3. Isn't vtprint the same as brettf's "ansilpr"?
  4. Why doesn't Netcom support vtprint (or something similiar)
     themselves?
  5. What about nuglops?  Shouldn't vtprint be a part of nuglops?
  6. I heard a rumor that Garrett might cancel his netcom account.  What
     does this mean for vtprint users on netcom?

I. About vtprint

  1. What is "vtprint"?

     vtprint is a program that allows someone to obtain seamless
     printing from a remote machine to their printer at home without
     requiring a TCP/IP connection to the remote machine or root access
     on the remote machine.  It will communicate over a serial line or
     a regular network connection.  Other methods of connection may also
     be possible.

     vtprint runs on the remote system (currently only UNIX-like systems
     are supported).  Software on your local machine may vary
     considerably.

  2. Who writes/supports vtprint?

     The author of vtprint is Garrett D'Amore.  He can be reached at 
     <[email-masked]>.  He is actively supporting vtprint
     users, and is working on new development with vtprint.

  3. Where do I get vtprint?

     If you are a UNIX sysadmin (or C programmer) you can get the
     orignal source archive for vtprint via ftp.  The current version is
     1.22 and can be found at ftp.netcom.com in /pub/garrett/ as a gzipped
     tar archive (vtprint-1.22.tar.gz).  THIS LOCATION IS EXPECTED TO 
     CHANGE: future versions of vtprint are expected to be located at
     ftp.sdsu.edu in the /pub/vtprint directory.  As of this writing,
     the next expected version is 1.4 (1.3 underwent some beta testing,
     but will not be "officially" released), which should be out
     sometime in early June 1994.

  4. What do I need to use vtprint?

     Well, to compile and install it, you need an ANSI C compiler.  (If
     your site has it installed already, you don't need to worry about
     this.)

     To use it, you need a terminal (or terminal emulator) that supports
     vt100 printer control escape sequences.  (ESC [5i and ESC [4i).  It
     is expected that vtprint 1.4 will support additional terminal
     printer escape sequences, such as Wyse 50 and Televideo 925 style 
     escapes.  (Note that some terminal emulations are compatible:
     currently ANSI, VT102, and VT220 are all known to support the same
     printer control codes as vt100.)

     You also need (obviously) a printer and some sort of connection to
     the remote host.

II. Installing vtprint 

  1. How do I install vtprint?

     If you are installing it on a host for everyone to use, you should
     follow a few simple steps.  First read the Makefile and make any
     changes you want.  (C compiler & flags, directories, etc.)

     Then compile vtprint by doing "make" in that directory.  (You may
     also want to do "make man" if you want to update the on-line
     documentation to reflect any changes you made in paths, etc.)

     Finally, do a "make install" to install the binaries and man pages
     in the appropriate locations.  Note that you *must* be a privileged
     user to execute this last step.

  2. What if I don't have root access on the remote host?

     If you don't have root access on the remote host, you can still
     install vtprint.  Do everything in part II-1 above, except "make
     install".  Instead do a "make userinstall" to install the actual
     binary and man page in personal directories.  (You may have to
     update your PATH or MANPATH environment variables to reflect these
     new settings.)

  3. I have an account on NETCOM.COM.  Do I need to install my own copy
     of vtprint?

     As of this writing, no.  Currently the author has an account on
     netcom.com, and a binary copy of vtprint owned by the author is
     made publicly available on netcom.com.  The executable is located
     in ~garrett/bin/vtprint, and the man page is in ~garrett/man/man1/
     as vtprint.1.  Please see the section titled NETCOM Users for more 
     information on setting up to use vtprint.

III. Using vtprint

  1. What help is available for using vtprint?

     First, there is the provided man page (vtprint.1).  Also there is
     a brief synopsis available by typing "vtprint -h".  Finally there
     are this FAQ and the author <[email-masked]>.

  2. How do I print text files using vtprint?

     Type "vtprint <filelist>".  There are also several options
     available.  See the man page for details on the options.
     Alternatively, you can use "vtprint" as the receiving end of a
     pipe.

  3. How do I print binary files using vtprint?

     Currently, vtprint does not support binary files.  This is because
     vtprint uses certain escape codes, and binary files may contain
     escape codes which will confuse vtprint (and possibly your terminal
     emulator).

  4. What about PostScript?

     Because PostScript is just ASCII text, vtprint can print PostScript
     to your printer.  But it DOES NOT know how to perform conversion
     from regular text to PostScript, which means that if your printer 
     is a PostScript only printer, you should set up some sort of filter
     to perform ASCII to PostScript conversion before piping it to
     vtprint.  For example, the following shell script might be used to
     send PostScript to a printer from a text file:

     #!/bin/sh
     while [ -n $1 ]; do { enscript $1 | vtprint; shift; }

  5. How do I set up program X to use vtprint?

     Most programs (e.g. Elm, Tin...) have a feature that allows the
     user to specify the name of the printing program that is used. 
     Normally this is set to "lpr" or somesuch.  You can generally
     replace "vtprint" for "lpr", replacing some options.  Some programs
     have difficulty because they suppress the <stdout> stream.  vtprint
     can use the tty device directly to get around this.  Use "vtprint
     -d" to get around this.  (Elm and tin both do this.)  This does
     cause a problem in some circumstances, because the mode for a tty
     device file is binary rather than text (on some systems).  The
     result is that newlines are handled differently.  See the Problems
     section below.

     Some programs may not need vtprint to print.  Pine is the only one
     that the author knows about.  (In fact, the vtprint program is
     derived in part from the printing code in Pine!)  You can select
     the "attached to ansi" print choice in Pine instead of using
     vtprint.

IV. Problems

  1. vtprint doesn't work!  Nothing is output by the printer, or the
     text appears on my screen but not on the printer.

     This is probably a problem with your communications package.  In
     all likelihood, your communications program may not support vt100
     printer escape codes.  Most MS-DOS and Windows packages do support
     these codes, but the author only knows of ONE Macintosh program and
     ONE Unix program that supports vtprint.  A simple thing to do is
     try "vtprint <somefile>" by itself.  If you get output, then
     your terminal emulator will probably work with vtprint.

     Read the file COMPAT for details about compatibility with various
     programs.

     Also, make sure that your printer is set up correctly.  Try
     printing from a local program, and make sure that the default is
     printing device is set to your printer.  (E.g. PRN: must be the
     same as the port your printer is on, under MS-DOS.)

  2. vtprint prints a single line, but additional lines are starting at
     the wrong horizontal location, or aren't showing up at all! or Why
     can't I get anything past the first line or two to print
     correctly?

     You may not have CR/LF mapping set up correctly on your printer,
     comm package, host.  You can change the settings in any of these
     locations to fix it.  Version 1.4 of vtprint will have a command
     line switch to provide a "better" solution.

     There are also several Unix programs (such as dos2unix) which can
     be used to filter the text and convert newlines as appropriate.

  3. Why aren't page breaks included between documents?

     Some terminal emulators don't handle formfeeds properly.  Telemate
     4.12 is known to eat them, and Microphone II requires a setting
     change to fix this problem.

V. NETCOM Users

  1. How do I use the master copy in ~garrett/bin on Netcom?

     Create an alias to ~garrett/bin/vtprint, or make a copy (or
     symbolic link) of vtprint and put it in a directory on your path
     (e.g. ~/bin).

  2. How do I view the man page on Netcom?

     Type the following: "nroff -man ~garrett/man/man1/vtprint.1 | less~

  3. Isn't vtprint the same as brettf's "ansilpr"?

     Yes and no.  It performs the same function, but it has some extra
     features.  In particular, "vtprint" is a C program and has support
     for signals (so hitting "CTRL-C" won't wreck your terminal state!)

     The last time the author checked, documentation/support for ansilpr
     was minimal at best.

     Also, version 1.4 will be able to support non-ansi (non-vt100)
     terminals.  This may be a plus for some users.

  4. Why doesn't Netcom support vtprint (or something similiar)
     themselves?

     Unknown.  Netcom support probably has a lot to do, and supporting a
     "non-core" program like vtprint takes extra resources.  However,
     since they are in the business of supporting dial-up accounts, it
     seems like they should support a program like "vtprint".

  5. What about nuglops?  Shouldn't vtprint be a part of nuglops?

     Perhaps.  The author suggested it be included in the nuglops list a
     while ago, but doesn't believe that they have ever followed up on
     this.  (But he also hasn't checked the nuglops list for several
     months.)

  6. I heard a rumor that Garrett might cancel his netcom account.  What
     does this mean for vtprint users on netcom?

     Garrett has internet service for free via work (also to his home).
     It doesn't really make sense for him to keep around his netcom
     account.  However, if he cancels, people who have been using the
     binary copy of vtprint in his directory won't be able to anymore.

     It is recommended that netcom users of vtprint make a physical copy
     (with "cp") of vtprint in their home directories.

     The author has had contact with netcom support to suggest that they
     might want to work something out, but no reply has yet been
     received.

     If a group of netcom users truly desires netcom-based support for
     vtprint, the author must have an account on vtprint.  Donations to
     the author or letters to netcom support may be helpful in obtaining
     such an account.

--
Mail submissions for comp.os.linux.announce to: [email-masked]
Be sure to include Keywords: and a short description of your software.